# Make rosco_m68k ROM kernel PoC
#
# Copyright (c)2023 Ross Bamford & contributors
# MIT LICENSE

ifndef ROSCO_M68K_DIR
$(error Please set ROSCO_M68K_DIR to the top-level rosco_m68k directory to use for rosco_m68k building)
endif

-include $(ROSCO_M68K_DIR)/user.mk

CPU?=68010
EXTRA_CFLAGS?=-g -O1 -fomit-frame-pointer
SYSINCDIR?=$(ROSCO_M68K_DIR)/code/software/libs/build/include
SYSLIBDIR?=$(ROSCO_M68K_DIR)/code/software/libs/build/lib
DEFINES=-DROSCO_M68K -DROSCO_M68K_KERNEL_BUILD -DUNIT_TESTS
FLAGS=-ffreestanding -ffunction-sections -fdata-sections							\
				-Wall -Wextra -Wno-unused-function 									\
				-Wno-unused-parameter -Wno-format -pedantic 						\
				-I$(SYSINCDIR) -Iinclude -Itests/include							\
				-mcpu=$(CPU) -march=$(CPU) -mtune=$(CPU) $(DEFINES)
CFLAGS=-std=c11 $(FLAGS)
CXXFLAGS=-std=c++20 -fno-exceptions -fno-rtti $(FLAGS)
GCC_LIBS=$(shell $(CC) --print-search-dirs 											\
		| grep libraries:\ =																								\
    | sed 's/libraries: =/-L/g' 																				\
    | sed 's/:/m68000\/ -L/g')m68000/
LIBS=-lrosco_m68k -lgcc
ASFLAGS=-mcpu=$(CPU) -march=$(CPU)

ifneq ($(ROSCO_M68K_HUGEROM),false)
LDSCRIPT?=$(SYSLIBDIR)/ld/serial/hugerom_rosco_m68k_program.ld
else
LDSCRIPT?=$(SYSLIBDIR)/ld/serial/rosco_m68k_program.ld
endif

LDFLAGS=-T $(LDSCRIPT) -L $(SYSLIBDIR) --gc-sections --oformat=elf32-m68k
VASMFLAGS=-Felf -m68000 -quiet -Lnf $(DEFINES)
CC=m68k-elf-gcc
CXX=m68k-elf-g++
AS=m68k-elf-as
NM=m68k-elf-nm
LD=m68k-elf-ld
OBJDUMP=m68k-elf-objdump
OBJCOPY=m68k-elf-objcopy
SIZE=m68k-elf-size
VASM=vasmm68k_mot
RM=rm -f

R68K_DIR=../r68k

.PHONY: clean test run

all: tests/units.bin tests/pmm.bin tests/list.bin multi.bin

include tests/include.mk

run: multi.bin
	$(R68K_DIR)/r68k $<

multi.bin: multi.elf
	$(OBJCOPY) -O binary $< $@

multi.elf: kmachine.o bitmap.o pmm.o slab.o list.o task.o sched.o api.o main.o
	$(LD) $(LDFLAGS) $(GCC_LIBS) $^ -o $@ $(LIBS)
	$(SIZE) $@
	-chmod a-x $@

%.o : %.c
	$(CC) -c $(CFLAGS) $(EXTRA_CFLAGS) -o $@ $<

%.o : %.cpp
	$(CXX) -c $(CXXFLAGS) $(EXTRA_CXXFLAGS) -o $@ $<

%.o : %.asm
	$(VASM) $(VASMFLAGS) $(EXTRA_VASMFLAGS) -L $(basename $@).lst -o $@ $<

# remove targets that can be generated by this Makefile
clean:
	$(RM) tests/rtest/*.o tests/*.o tests/*.bin tests/*.elf *.o *.bin *.elf *.lst
